{#
Template for the install page that contains installation instructions
for the users that have not installed NICE yet.
Author: Jero Schäfer
Last modified: 18.06.2020
#}
{% extends "base.html" %}

{% block page_content %}
    <main role="main">
        <section class="jumbotron text-center">
            <div class="container">
                <h1 class="jumbotron-heading">How To Install</h1>
                <p class="lead text-muted">
                    The following steps provide an installation manual.
                </p>
            </div>
        </section>
        <h2 class="mb-1">Project Installation</h2>
        <p class="lead">
            To participate in the NICE Blockchain by hosting your own NICE node(s),
            please follow the installation instructions listed below.
        </p>
        <ul class="list-group">
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <p class="lead">
                        1. Clone the <a href="https://gitlab.gwdg.de/jonathan.decker/NICE">GitHub</a>
                        repository to a folder.
                    </p>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <p class="lead">
                        2. Make sure Python 3.8+ is installed (older versions might work but aren't tested).
                    </p>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <p class="lead">
                        3. Install IPFS command line tool from
                        <a href="https://docs.ipfs.io/how-to/command-line-quick-start/">here</a>.
                        Make sure to add to your PATH. You can test it with <code>ipfs daemon</code>.
                    </p>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <p class="lead">
                        4. Create a virtual env and activate it.
                    </p>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <p class="lead">
                        5. Install dependencies via <code>pip install -r requirements.txt</code>.
                    </p>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <p class="lead">
                        6. Configure config.py (see Configuration section below)
                    </p>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <p class="lead">
                        7. Start the node by running <code>python main.py</code>
                    </p>
                </div>
            </li>
        </ul>

        <h2 class="mb-1">Node Configuration</h2>
        <p class="lead">
            Configuration is handled via the config.py file. Here the project may be configured
            using python code syntax. The default configuration should work out of the box but
            further adjustments can be made following these guidelines:
        </p>
        <ul class="list-group">
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <h4 class="mb-1">Flask configuration</h4>
                    <ul class="list-group">
                        <li class="list-group-item">
                            <h5 class="mb-1">FLASK_ENABLED:</h5>
                            <p>
                                Whether or not a flask server should be started.
                                If set to false, no website will be available to add new blocks.
                            </p>
                        </li>
                        <li class="list-group-item">
                            <h5 class="mb-1">FLASK_PORT:</h5>
                            <p>
                                The port on which the flask server should listen. When accessing
                                the website via the browser, the port needs to be appended to the
                                address, for example "localhost:5000", to access the local node on
                                port 5000. The port has to be available and not preoccupied.
                            </p>
                        </li>
                        <li class="list-group-item">
                            <h5 class="mb-1">FLASK_HOST:</h5>
                            <p>
                                The interface on which the flask server should listen.
                                For only local usage, simply set to "127.0.0.1" or "localhost".
                                Should also work with a public domain, but this is not tested.
                            </p>
                        </li>
                    </ul>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <h4 class="mb-1">IPFS configuration</h4>
                    <ul class="list-group">
                        <li class="list-group-item">
                            <h5 class="mb-1">IPFS_ENABLED:</h5>
                            <p>
                                Will attempt to start the IPFS daemon with the command "ipfs daemon"
                                when set to true. In case the ipfs daemon is already running, this
                                can be set to false, but it can also be left on true, the attempt to
                                start the ipfs daemon again will fail, but the system will be able to
                                use the running daemon anyway.
                            </p>
                        </li>
                    </ul>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <h4 class="mb-1">P2P configuration</h4>
                    <ul class="list-group">
                        <li class="list-group-item">
                            <h5 class="mb-1">P2P_PORT:</h5>
                            <p>
                                The port the p2p server should listen on. Over this port, the node will
                                receive updates about the chain from other nodes. The port has to be
                                available and not preoccupied.
                            </p>
                        </li>
                        <li class="list-group-item">
                            <h5 class="mb-1">P2P_HOST:</h5>
                            <p>
                                The interface on which the p2p server should run.
                                Should be the same as FLASK_HOST.
                            </p>
                        </li>
                        <li class="list-group-item">
                            <h5 class="mb-1">P2P_BOOTSTRAP:</h5>
                            <p>
                                List of interface:port pairs from other nodes. Here the interface and
                                port of at least one other node should be entered, to get started with
                                the p2p network and learn about further nodes from it. If this is the
                                only node or the first node in the network, no change is needed.
                            </p>
                        </li>
                        <li class="list-group-item">
                            <h5 class="mb-1">P2P_NODES_FILE:</h5>
                            <p>
                                The list of known nodes needs to be saved to a file, to persist beyond
                                restarts of the node. The path may either be relative to the project
                                folder or absolute.
                            </p>
                        </li>
                    </ul>
                </div>
            </li>
            <li class="list-group-item">
                <div class="d-flex w-100 justify-content-between">
                    <h4 class="mb-1">Blockchain configuration</h4>
                    <ul class="list-group">
                        <li class="list-group-item">
                            <h5 class="mb-1">BLOCKCHAIN_FILE:</h5>
                            <p>
                                The current state of the blockchain needs to be saved to a file,
                                to persist beyond restarts of the node. The path may either be
                                relative to the project folder or absolute.
                            </p>
                        </li>
                        <li class="list-group-item">
                            <h5 class="mb-1">QUEUE_FILE:</h5>
                            <p>
                                The current local queue of transactions needs to be saved to a file to
                                persist beyond restarts of the node. The path my either be relative to
                                the project folder or absolute.
                            </p>
                        </li>
                        <li class="list-group-item">
                            <h5 class="mb-1">BLOCKCHAIN_ID:</h5>
                            <p>
                                The id is the hash of the very first block of NICE blockchain. To avoid
                                merging two chains from different NICE blockchains on the same network,
                                only nodes with the same blockchain id will exchanged messages. Either
                                set this to None, to create a new chain or to the blockchain id of an
                                existing NICE blockchain. This node will fetch the blockchain from another
                                node. In case the blockchain file already exists, the blockchain id from
                                the loaded blockchain will be used instead and this option will be ignored.
                                So to force the creation of a new blockchain, the blockchain file must not exist.
                            </p>
                        </li>
                    </ul>


                </div>
            </li>
        </ul>

    </main>
{% endblock %}